<?php
/* vim: set expandtab tabstop=2 shiftwidth=2: */

function default_http_reader(&$arr) {
  foreach($arr as $name => $dmy) {
    if (is_array($arr[$name])) {
      default_http_reader(&$arr[$name]);
    } else {
      $arr[$name] = mb_ereg_replace('', ' ', $arr[$name]);
      $arr[$name] = trim($arr[$name]);
      if (strstr($name, 'KANA')) {
        $arr[$name] = mb_convert_kana($arr[$name], 'C');
      }
      if ($name == '__z__base64') {
        $arr['__z'] = base64_decode($arr[$name]);
      }
    }
  }
}

?>
