<?php
/* vim: set expandtab tabstop=2 shiftwidth=2: */

function check_mail_edit($rec, $field, &$err) {
  if (!trim($rec[$field])) return;
  $mail = trim($rec[$field]);
  $user_id = $rec['USER_ID'];
  $rec_user = pm9db::select_item("select count(*) from tbl_USER where USER_ID != '$user_id' and USER_MAIL = '$mail'");
  if ($rec_user > 0) {
    $err[$field] = 'exist_mail';
  }
}

function check_mail_inst($rec, $field, &$err) {
  if (!trim($rec[$field])) return;
  $mail = trim($rec[$field]);
  $rec_user = pm9db::select_item("select count(*) from tbl_USER where USER_MAIL = '$mail'");
  if ($rec_user > 0) {
    $err[$field] = 'exist_mail';
  }
}


function default_validator(&$rec, $field_name, $f_attr1, $f_attr2, &$__err_list) {
	if (!is_array($rec)) return;
  if (!$__err_list) $__err_list = array();

  $rec[$field_name] = trim($rec[$field_name]);

  if ($f_attr1 == 'option' && !$rec[$field_name]) {
    return;
  }

  if ($f_attr1 == 'equal') {
    validate::check_equal($rec, $field_name, &$__err_list);
    return;
  }

  if ($f_attr1 == 'mail_edit') {
    if ($rec['USER_ID']) {
      check_mail_edit($rec, $field_name, &$__err_list);
    } else {
      check_mail_inst($rec, $field_name, &$__err_list);
    }
    return;
  }

  validate::check_require($rec, $field_name, &$__err_list);

  if (strstr($field_name, 'NAME')) {
    validate::check_kanji($rec, $field_name, &$__err_list);
  }
  if (strstr($field_name, 'PRICE')) {
    validate::check_price($rec, $field_name, &$__err_list);
  }
  if (strstr($field_name, 'KANA')) {
    validate::check_kana($rec, $field_name, &$__err_list);
  }
  if (strstr($field_name, 'TEL')) {
    validate::check_tel($rec, $field_name, &$__err_list);
  }
  if (strstr($field_name, 'MAIL')) {
    validate::check_mail($rec, $field_name, &$__err_list);
  }
  if (strstr($field_name, 'PASS')) {
    validate::check_passwd($rec, $field_name, &$__err_list);
  }
  if (strstr($field_name, 'DATE') || strstr($field_name, 'BIRTHDAY')) {
    validate::check_date($rec, $field_name, &$__err_list);
  }
} 
?>
