<?php
/* vim: set expandtab tabstop=2 shiftwidth=2: */

class pm9db extends pm9db_core {

  function setup_extteim(&$rec) {
    $user =& pm9mvc::get_pvars('mng_login');
    $rec['INSERT_DATE'] = 'NOW()';
    $rec['INSERT_STF'] = "{$user['STAFF_L_NAME']}{$user['STAFF_F_NAME']}";
    $rec['MODIFY_DATE'] = 'NOW()';
    $rec['MODIFY_STF'] = "{$user['STAFF_L_NAME']}{$user['STAFF_F_NAME']}";
    $rec['REMOTE_ADDR'] = $_SERVER['REMOTE_ADDR'];
    $rec['USER_AGENT'] = $_SERVER['HTTP_USER_AGENT'];
  }

	function insert_record_autoinc($table, $key_list, $append_key, $rec, $exclude_item = array()) {
    pm9mvc::_check_args(func_get_args(), 'pm9db::insert_record_autoinc',
      array('table' => 'str', 'key_list' => 'array', 'append_key' => 'str', 'rec' => 'array', 'exclude_item = array' => 'array'));

    pm9db::setup_extteim(&$rec);
    $exclude_item[] = 'MODIFY_DATE';
    $exclude_item[] = 'MODIFY_STF';

	  pm9db_core::insert_record_autoinc($table, $key_list, $append_key, $rec, $exclude_item);
  }


	function insert_record($table, $rec, $exclude_item = array()) {
    pm9mvc::_check_args(func_get_args(), 'pm9db::insert_record',
      array('table' => 'str', 'rec' => 'array', 'exclude_item = array()' => 'array'));

    pm9db::setup_extteim(&$rec);
    $exclude_item[] = 'MODIFY_DATE';
    $exclude_item[] = 'MODIFY_STF';

	  return pm9db_core::insert_record($table, $rec, $exclude_item);
  }


	function update_record($table, $key_list, $rec, $update_item = array(), $exclude_update_item = array(), $exclude_check_item = array()) {
    pm9mvc::_check_args(func_get_args(), 'pm9db::update_record',
      array('table' => 'str', 'key_list' => 'array', 'rec' => 'array', 'update_item = array()' => 'array', 'exclude_update_item = array()' => 'array', 'exclude_check_item = array()' => 'array'));

    pm9db::setup_extteim(&$rec);
    $exclude_update_item[] = 'INSERT_DATE';
    $exclude_update_item[] = 'INSERT_STF';

	  pm9db_core::update_record($table, $key_list, $rec, $update_item, $exclude_update_item, $exclude_check_item);
  }


	function insert_update_record($table, $key_list, $rec, $exclude_insert_item = array(), $update_item = array(), $exclude_update_item = array(), $exclude_check_item = array()) {
    pm9mvc::_check_args(func_get_args(), 'pm9db::insert_update_record',
      array('table' => 'str', 'key_list' => 'array', 'rec' => 'array', 'exclude_insert_item = array()' => 'array', 'update_item = array()' => 'array', 'exclude_update_item' => 'array', 'exclude_check_item = array()' => 'array'));

    pm9db::setup_extteim(&$rec);
    $exclude_insert_item[] = 'MODIFY_DATE';
    $exclude_insert_item[] = 'MODIFY_STF';
    $exclude_update_item[] = 'INSERT_DATE';
    $exclude_update_item[] = 'INSERT_STF';

	  pm9db_core::insert_update_record($table, $key_list, $rec, $exclude_insert_item, $update_item, $exclude_update_item, $exclude_check_item);
  }
}

?>
