<?
function ____($new_label) {
  global $__trace_mode_coverage;

  if (!$__trace_mode_coverage) return;

  $arr = debug_backtrace();
  $new_fn = $arr[0]['file'];

  $APP_DIR = APP_DIR;
  $LOG_DIR = LOG_DIR;

  $debug_list = array();

  if (file_exists("$LOG_DIR/coverage.flow")) {
    $fp = fopen("$LOG_DIR/coverage.flow", "r");
    flock($fp, LOCK_SH);
    while($line = fgets($fp)) {
      if (preg_match('/# (.*?) :: (.*?)$/', $line, $match)) {
        $fn = trim($match[1]);
        $debug_list[$fn]['.'] = trim($match[2]);
      } else if (preg_match('/@@@@@@ (.*?)\t(.*?)$/', $line, $match)) {
        $label = trim($match[1]);
        $debug_list[$fn][$label] = trim($match[2]);
      }
    }
    pclose($fp);
  }

  $debug_list[$new_fn][$new_label] = strftime('%Y/%m/%d %H:%M:%S');

  ksort($debug_list);
  $fp = fopen("$LOG_DIR/coverage.flow", "w");
  flock($fp, LOCK_EX);
  foreach($debug_list as $fn => $tmp) {
    fwrite($fp, "# $fn :: {$tmp['.']}\n");
    foreach($tmp as $key => $val) {
      if ($key == '.') continue;
      fwrite($fp, "\t@@@@@@ $key\t$val\n");
    }
  }
  fclose($fp);
}
?>
