<?
/* vim: set expandtab tabstop=2 shiftwidth=2: */

/*
 * PM9 Web Framework
 * (C) 2004, Kunimasa Noda/PM9.com, Inc. <http://www.pm9.com,  kuni@pm9.com>
 * see file LICENSE for license details
 */


class pm9db_core {

	function db_start() {
		global $__cn_global;
		global $__cn_local;
	
		if (!($__cn_global = mysql_pconnect(DB_HOST_GLOBAL, DB_USER, DB_PASS))) {
			die;
		} 
		if (DB_HOST_GLOBAL == DB_HOST) {
			$__cn_local = $__cn_global;
		} else {
			if (!($__cn_local = mysql_pconnect(DB_HOST, DB_USER, DB_PASS))) {
				die;
			} 
		} 
		if (!(mysql_select_db(DB_NAME, $__cn_local))) {
			die;
		} 
	} 
	

	function db_end() {
		global $__cn_global;
		global $__cn_local;
		// mysql_close($__cn_global);
		// mysql_close($__cn_local);
	} 
	

	function get_seq($name) {
    pm9mvc::_check_args(func_get_args(), 'pm9db::get_seq',
      array('name' => 'str'));

		$name = mysql_escape_string($name);
		$sql = "select seq from mst_seq where name = '$name'";
		if (!($rs = pm9db::query($sql))) {
			die;
		} 
		if ($item = mysql_fetch_array($rs)) {
			$seq = $item['seq'];
			$seq++;
			$sql = "update mst_seq set seq = $seq where name = '$name'";
			pm9db::query($sql);
		} else {
			$seq = 1;
			$sql = "insert into mst_seq (name, seq) values ('$name', $seq)";
			pm9db::query($sql);
		} 
		return $seq;
	} 


	function db_switch($sql) {
    pm9mvc::_check_args(func_get_args(), 'pm9db::db_switch',
      array('sql' => 'str'));

	  global $__cn_global;
	  global $__cn_local;
	
	  if (db_check_global($sql)) {
	    if (!(mysql_select_db(DB_NAME_GLOBAL, $__cn_global))) {
	      die;
	    }
      return 1;
	  } else {
	    if (!(mysql_select_db(DB_NAME, $__cn_local))) {
	      die;
	    }
      return 0;
	  }
	}


	function get_db_fieldlist($table) {
	  $db_fieldlist = array();
	  if (pm9db::db_switch($table)) {
	    $fds = @mysql_list_fields(DB_NAME_GLOBAL, $table);
	  } else {
	    $fds = @mysql_list_fields(DB_NAME, $table);
	  }
	  for ($j = 0; ($fd = @mysql_field_name($fds, $j)) != false; $j++) {
	    $ft = @mysql_field_type($fds, $j);
	    $db_fieldlist[$fd] = $ft;
	  }
	  return $db_fieldlist;
	}


	function insert_record_autoinc($table, $key_list, $append_key, $rec, $exclude_item = array()) {
    pm9mvc::_check_args(func_get_args(), 'pm9db::insert_record_autoinc',
      array('table' => 'str', 'key_list' => 'array', 'append_key' => 'str', 'rec' => 'array', 'exclude_item = array' => 'array'));

    $table_field = pm9db::get_db_fieldlist($table);
    $rec = pm9db::_regular($table_field, $rec);
    $no = pm9db::_max_record_no($table, $table_field, $key_list, $append_key, $rec, &$sql_where);
    $rec[$append_key] = $no + 1;
    pm9db::_insert_record($table, $table_field, $rec, $exclude_item);
  }


	function insert_record($table, $rec, $exclude_item = array()) {
    pm9mvc::_check_args(func_get_args(), 'pm9db::insert_record',
      array('table' => 'str', 'rec' => 'array', 'exclude_item = array()' => 'array'));

    $table_field = pm9db::get_db_fieldlist($table);
    $rec = pm9db::_regular($table_field, $rec);
    pm9db::_insert_record($table, $table_field, $rec, $exclude_item);
		return mysql_insert_id();
  }


	function update_record($table, $key_list, $rec, $update_item = array(), $exclude_update_item = array(), $exclude_check_item = array()) {
    pm9mvc::_check_args(func_get_args(), 'pm9db::update_record',
      array('table' => 'str', 'key_list' => 'array', 'rec' => 'array', 'update_item = array()' => 'array', 'exclude_update_item = array()' => 'array', 'exclude_check_item = array()' => 'array'));

    $table_field = pm9db::get_db_fieldlist($table);
    $rec = pm9db::_regular($table_field, $rec);
    $sql_where = pm9db::_setup_where($table_field, $key_list, $rec);
	  pm9db::_update_record($table, $table_field, $sql_where, $rec, $update_item, $exclude_update_item, $exclude_check_item);
  }


	function insert_update_record($table, $key_list, $rec, $exclude_insert_item = array(), $update_item = array(), $exclude_update_item = array(), $exclude_check_item = array()) {
    pm9mvc::_check_args(func_get_args(), 'pm9db::insert_update_record',
      array('table' => 'str', 'key_list' => 'array', 'rec' => 'array', 'exclude_insert_item = array()' => 'array', 'update_item = array()' => 'array', 'exclude_update_item' => 'array', 'exclude_check_item = array()' => 'array'));

    $table_field = pm9db::get_db_fieldlist($table);
    $rec = pm9db::_regular($table_field, $rec);
    $no = pm9db::_count_record($table, $table_field, $key_list, $rec, &$sql_where);
    if ($no) {
      pm9db::_update_record($table, $table_field, $sql_where, $rec, $update_item, $exclude_update_item, $exclude_check_item);
    } else {
	    pm9db::_insert_record($table, $table_field, $rec, $exclude_insert_item);
    }
  }


	function _insert_record($table, $table_field, $rec, $exclude) {
	
    $unassigned_arr = array();
		$comma = "";
		foreach($table_field as $field_name => $field_type) {
			if (in_array($field_name, $exclude)) continue;
	
			$sql_key .= $comma . $field_name;

      if (!array_key_exists($field_name, $rec)) {
        $unassigned_arr[] = $field_name;
      }

			$value = mysql_escape_string($rec[$field_name]);
			if ($field_type == 'datetime' || $field_type == 'date' || $field_type == 'time') {
			  if ($value == '') {
			  	$sql_val .= $comma . 'NULL';
        } else if ($value == 'NOW()') {
			  	$sql_val .= $comma . 'NOW()';
        } else {
				  $sql_val .= $comma . "'$value'";
        }
			} else {
				$sql_val .= $comma . "'$value'";
			} 
			$comma = ',';
		} 
    
		$query = "insert into $table ($sql_key) values ($sql_val)";
    pm9db::_debug_query_unassigned($query, $unassigned_arr);
		pm9db::query($query);
	} 


	function _update_record($table, $table_field, $sql_where, $rec, $update_item, $exclude_update_item, $exclude_check_item) {
		$rs_check = pm9db::query("select * from $table $sql_where");
		$rec_check = mysql_fetch_array($rs_check);
		$update_flag = false;
		foreach($table_field as $field_name => $field_type) {
			if (in_array($field_name, $exclude_check_item)) continue;
	
			if ($rec_check[$field_name] != $rec[$field_name]) {
				$update_flag = true;
				break;
			} 
		} 
		if (!$update_flag) return;
	
    $unassigned_arr = array();
		$comma = "";
		foreach($table_field as $field_name => $field_type) {
      if (count($update_item) && !in_array($field_name, $update_item)) continue;
			if (in_array($field_name, $exclude_update_item)) continue;

      if (!array_key_exists($field_name, $rec)) {
        $unassigned_arr[] = $field_name;
      }

			$value = mysql_escape_string($rec[$field_name]);
			if ($field_type == 'datetime' || $field_type == 'date' || $field_type == 'time') {
			  if ($value == '') {
			  	$sql_item .= $comma . "$field_name=NULL";
        } else if ($value == 'NOW()') {
          $sql_item .= $comma . "$field_name=NOW()";
        } else {
          $sql_item .= $comma . "$field_name='$value'";
        }
			} else {
				$sql_item .= $comma . "$field_name='$value'";
			} 
			$comma = ',';
		} 

		$query = "update $table set $sql_item $sql_where";
    pm9db::_debug_query_unassigned($query, $unassigned_arr);
		pm9db::query($query);
	} 


  function _setup_where($table_field, $key_list, $rec) {
		$first_column = true;
		foreach($key_list as $key) {
			$value = mysql_escape_string($rec[$key]);
      $item_key = $key;
      if (strstr($key, ',save')) {
        $item_key = str_replace(',save', '', $key);
      }
			if ($first_column) {
				$sql_where = " where $item_key='$value'";
			} else {
				$sql_where .= " and $item_key='$value'";
			} 
			$first_column = false;
		} 
		return $sql_where;
  }


  function _count_record($table, $table_field, $key_list, $rec, &$sql_where) {
    $sql_where = pm9db::_setup_where($table_field, $key_list, $rec);
		$rs = pm9db::query("select count(*) from $table $sql_where");
		$rec = mysql_fetch_array($rs);
		return $rec[0];
  }


  function _max_record_no($table, $table_field, $key_list, $append_key, $rec, &$sql_where) {
    $sql_where = pm9db::_setup_where($table_field, $key_list, $rec);
		$rs = pm9db::query("select max($append_key) from $table $sql_where");
		$rec = mysql_fetch_array($rs);
		return $rec[0];
  }


  function _regular($table_field, $rec) {
		foreach($table_field as $field_name => $field_type) {
      $field_data = mysql_escape_string($rec[$field_name]);
			switch ($field_type) {
				case 'datetime':
				case 'date':
					$rec[$field_name] = str_replace('T', ' ', $rec[$field_name]);
					break;
				case 'int':
				case 'real':
					$rec[$field_name] = str_replace(',', '', $rec[$field_name]);
					break;
				default:
					break;
			} 
		} 
    return $rec;
  }

	
	function escape_array($arr) {
    pm9mvc::_check_args(func_get_args(), 'pm9db::gscape_array',
      array('arr' => 'array'));

    $ret = array();
    foreach($arr as $key => $val) {
		  $ret[$key] = mysql_escape_string($val);
    }
    return $ret;
	} 


	function escape($arr) {
    pm9mvc::_check_args(func_get_args(), 'pm9db::escape',
      array('arr' => 'any'));

    if (is_array($arr)) {
      $ret = array();
      foreach($arr as $key => $val) {
		    $ret[$key] = mysql_escape_string($val);
      }
    } else {
		  $ret = mysql_escape_string($arr);
    }
    return $ret;
	} 


	function save_recordkey(&$arr, $key_list) {
    pm9mvc::_check_args(func_get_args(), 'pm9db::gscape_array',
      array('arr' => 'array'), array('key_list' => 'array'));

    foreach($arr as $key => $val) {
			if (in_array($key, $key_list)) {
		    $arr["$key,save"] = $arr[$key];
      }
    }
	} 

	
	function query($sql) {
    pm9mvc::_check_args(func_get_args(), 'pm9db::query',
      array('sql' => 'str'));

    global $__trace_mode_db_dump;
    global $__trace_mode_log;

    if ($__trace_mode_db_dump) {
      require('trace_start.php');
      echo "@@@ QUERY: ";
      echo "$sql\n\n";
      require('trace_end.php');
    }

    if ($__trace_mode_log) {
      if (preg_match('/^(insert|INSERT|update|UPDATE)/', $sql)) {
        pm9mvc::log($sql);
      }
    }

		pm9db::db_switch($sql);
		$ret = @mysql_query($sql);
		$err = mysql_error();
		if ($err) {
      trigger_error("$sql\n$err", E_USER_ERROR);
		} 
		return $ret;
	} 

	// QueryȤΩ
	function add_select_condition($value, &$sqladd, $condition) {
		if (strlen($value) != 0) {
			if ($sqladd) {
				$sqladd .= ' and ';
			} else {
				$sqladd .= ' where ';
			} 
			$sqladd .= "$item_name $condition";
		} 
	} 

	function add_select_cond_tbl($value, &$sqladd, &$sqltbl, $condition, $arrtbl) {
		if (strlen($value) != 0) {
			if ($sqladd) {
				$sqladd .= ' and ';
			} else {
				$sqladd .= ' where ';
			} 
			$sqladd .= "$item_name $condition";

      if (!is_array($sqltbl)) {
        $sqltbl = array();
      }
      foreach($arrtbl as $tbl) {
        if (!in_array($tbl, $sqltbl)) {
          $sqltbl[] = $tbl;
        }
      }
		} 
	} 
	

	function select_single($condition) {
    pm9mvc::_check_args(func_get_args(), 'pm9db::select_single',
      array('query' => 'str'));

		$rs = pm9db::query($condition);
		$rec = mysql_fetch_array($rs, MYSQL_ASSOC);
		return $rec;
	} 


	function select_item($condition) {
    pm9mvc::_check_args(func_get_args(), 'pm9db::select_item',
      array('query' => 'str'));

		$rs = pm9db::query($condition);
		$rec = mysql_fetch_array($rs);
		return $rec[0];
	} 
	

	function select_assoc($condition) {
    pm9mvc::_check_args(func_get_args(), 'pm9db::select_assoc',
      array('query' => 'str'));

		$list = array();
		$rs = pm9db::query($condition);
		while ($rec = mysql_fetch_array($rs)) {
		 $list[$rec[0]] = $rec[1];
		} 
		return $list;
	} 


	function select_assoc_array($condition, $key_items) {
    pm9mvc::_check_args(func_get_args(), 'pm9db::select_assoc_array',
      array('query' => 'str', 'key_items' => 'array'));

		$list = array();
		$rs = pm9db::query($condition);
		while ($rec = mysql_fetch_array($rs, MYSQL_ASSOC)) {
      $key = '';
      foreach($key_items as $tmp) {
        $key .= '["'.$rec[$tmp].'"]';
      }
      eval("\$list$key = \$rec;");
		} 
		return $list;
	} 


	function select_array($condition) {
    pm9mvc::_check_args(func_get_args(), 'pm9db::select_array',
      array('query' => 'str'));

		$list = array();
		$rs = pm9db::query($condition);
		while ($rec = mysql_fetch_array($rs, MYSQL_ASSOC)) {
      $list[] = $rec;
		} 
		return $list;
	} 


  function fetch_array($rs, $arr_type=MYSQL_ASSOC) {
    return mysql_fetch_array($rs, $arr_type);
  }


  function fetch_array_simple($rs) {
    return mysql_fetch_array($rs, MYSQL_BOTH);
  }

  function _debug_query_unassigned($query, $unassigned_arr) {
    global $__trace_mode_query_unassigned;
    if (!$__trace_mode_query_unassigned) return;
    if (!count($unassigned_arr)) return;

    $LOG_DIR = LOG_DIR;

    $ti = strftime('%Y/%m/%d %H:%M:%S');

    $arr = debug_backtrace();
    for($i=0; $i<count($arr); $i++) {
      $php_fn = $arr[$i]['file'];
      if (strstr($php_fn, 'ThePM9.com')) continue;
      $line = $arr[$i]['line'];
      if (!(strstr($php_fn, '_include') || strstr($php_fn, '_config'))) break;
    }
    $php_ti = strftime('%Y/%m/%d %H:%M:%S', filemtime($php_fn));

    $fp = fopen("$LOG_DIR/unassigned.query", "a");
    flock($fp, LOCK_EX);
    fwrite($fp, "### $ti\n");
    fwrite($fp, "# $php_fn ($line): $php_ti\n");
    fwrite($fp, "# $query\n");
    foreach($unassigned_arr as $err_field) {
      fwrite($fp, "\t@@@@@@ $err_field\n");
    }
    fclose($fp);
  }
}

?>
