<?
/* vim: set expandtab tabstop=2 shiftwidth=2: */

session_start();
$__sess = &$_SESSION['__sess'];
$__portletvars = &$_SESSION['__portletvars'];
$__cache = &$_SESSION['__cache'];
$__cache_time = &$_SESSION['__cache_time'];
$__validate_form_list = &$_SESSION['__validate_form_list'];
$__ap_last_state = &$_SESSION['__ap_last_state'];

pm9db::db_start();

if ($__sess == null || $_POST['__CLEAR_SESSION']) {
	$__sess = array();
	$__portletvars = array();
	session_register('__sess');
	session_register('__portletvars');

	$__cache = array();
	$__cache_time = array();
	session_register('__cache');
	session_register('__cache_time');

	$__validate_form_list = array();
	session_register('__validate_form_list');

	$__ap_last_state = array();
	session_register('__ap_last_state');

  $__start = true;
} 


if ($_POST['__trace']) $__sess['__trace'] = $_POST['__trace'];
if ($__sess['__trace']) {
  list($__trace_mode, $__trace_title) = split(',', $__sess['__trace']);
  if (strstr($__trace_mode, 'p')) $__trace_mode_post_dump = true;
  if (strstr($__trace_mode, 's')) $__trace_mode_sess_dump = true;
  if (strstr($__trace_mode, 't')) $__trace_mode_tpl_dump = true;
  if (strstr($__trace_mode, 'a')) $__trace_mode_ap_sess_dump = true;
  if (strstr($__trace_mode, 'h')) $__trace_mode_html_dump = true;
  if (strstr($__trace_mode, 'd')) $__trace_mode_db_dump = true;
  if (strstr($__trace_mode, 'l')) $__trace_mode_log = true;
  if (strstr($__trace_mode, 'z')) $__trace_mode_ap_last_state = true;

  if (strstr($__trace_mode, 'F')) $__trace_mode_coverage = true;
  if (strstr($__trace_mode, 'A')) $__trace_mode_action = true;
  if (strstr($__trace_mode, 'U')) $__trace_mode_html_unassigned = true;
  if (strstr($__trace_mode, 'Q')) $__trace_mode_query_unassigned = true;
}

if ($__trace_mode_post_dump || $__trace_mode_sess_dump || $__trace_mode_tpl_dump || $__trace_mode_ap_sess_dump || $__trace_mode_html_dump || $__trace_mode_db_dump || $__trace_mode_ap_last_state) {
  require('trace_start.php');
  echo "###### $__trace_title  " . strftime('%Y/%m/%d %H:%M:%S') . "\n";
  echo "\n";
  require('trace_end.php');
}
if ($__trace_mode_sess_dump) {
  require('trace_start.php');
  echo "@@@ SESSION:\n\n";
  echo '$__sess : ';
  var_dump($__sess);
  echo '$__portletvars : ';
  var_dump($__portletvars);
  echo '$__validate_form_list : ';
  var_dump($__validate_form_list);
  echo "\n\n";
  require('trace_end.php');
}
if ($__trace_mode_post_dump) {
  require('trace_start.php');
  echo "@@@ REQUEST:\n\n";
  echo '$_POST : ';
  var_dump($_POST);
  echo "\n\n";
  require('trace_end.php');
}


$__validate_form_counter = 1;


$__debug_action = '';
$__debug_refresh = '';
if ($_POST['_ACTION_']) {
  $__action = $_POST['_ACTION_'];
  $__debug_action = "_ACTION_.value='$__action'";
  if (strstr($__action, '::')) {
    list($__action, $__tmp_akey, $__tmp_atmp) = split('::', $__action);
    $__debug_action = "_ACTION_.value='$__action::$__tmp_akey::xxx'";
    $_POST[$__tmp_akey] = $__tmp_atmp;
  }
}

if ($_POST['_ACTION']) {
  foreach($_POST['_ACTION'] as $__pkey => $__ptmp) {
    $__action = $__pkey;
    $__debug_action = "_ACTION[$__action]";
    if (strstr($__action, '::')) {
      list($__action, $__tmp_akey, $__tmp_atmp) = split('::', $__action);
      $__debug_action = "_ACTION[$__action::$__tmp_akey::xxx]";
      $_POST[$__tmp_akey] = $__tmp_atmp;
    }
  }
}

function array_merge2($paArray1, $paArray2) {
   if (!is_array($paArray1) or !is_array($paArray2)) { return $paArray2; }
   foreach ($paArray2 AS $sKey2 => $sValue2) {
       $paArray1[$sKey2] = array_merge2(@$paArray1[$sKey2], $sValue2);
   }
   return $paArray1;
}


if ($_POST['__z']) {
  list($__v, $__sess_seq_old, $__sess_seq) = split('\.', $_POST['__z']);
  list($__validate_tpl, $__post_ap_id, $__post_pvar_id, $__post_ap_state, $tmp_frame) = $__validate_form_list[$__sess_seq_old][$__v];
  if (pm9mvc::check_reload()) {
    $__sess['__frame'] = $tmp_frame;
  }

  if ($__post_ap_id) {

    $__tmp_post = array();
    foreach($_POST as $__key => $__val) {
      if (substr($__key, 0, 2) == '__') continue;
      if (__key == '_ACTION') continue;
      $__tmp_post[$__key] = $__val;
    }

    $__portletvars[$__post_pvar_id] = array_merge2($__portletvars[$__post_pvar_id], $__tmp_post);

    $__portletvars["_$__post_pvar_id"] = $__portletvars[$__post_pvar_id];
  }

  if ($_POST['_REFRESH']) {
    $__debug_refresh = '1';
    $__cache_time[$__post_ap_id] = 0;
    $_POST['_REFRESH'] = null;
  }
}


if ($_POST['_ACTION_HISTORY_BACK']) {
  $__debug_action = "_ACTION_HISTORY_BACK[{$_POST['_ACTION_HISTORY_BACK']}]";
  foreach($_POST['_ACTION_HISTORY_BACK'] as $back_count => $tmp) {
    if (is_numeric($back_count)) {
      $target = $__sess_seq - $back_count;
    } else {
      $target = -1;
      for($i = $__sess_seq; $i >= 0; $i--) {
        if ($__validate_form_list[$i]) foreach($__validate_form_list[$i] as $tmp) {
          list($dmy, $dmy, $dmy, $dmy, $dmy, $history_mark) = $tmp;
          if ($history_mark == $back_count) {
            $target = $i;
            $i = -1;
            break;
          }
        }
      }
    }


    if ($target >= 0) {
      foreach($__validate_form_list[$target] as $tmp) {
        list($__validate_tpl, $__post_ap_id, $__post_pvar_id, $__post_ap_state, $__frame, $history_mark) = $tmp;
        $__sess['__frame'] = $__frame;
        pm9mvc::exec_portlet($__post_ap_id, $__post_ap_state);
      }
    }
    $__post_ap_id = null;
  }
}


if ($__trace_mode_action && $_POST['__z'] && ($__debug_action || $__debug_refresh)) {
  $LOG_DIR = LOG_DIR;

  $debug_list = array();

  if (file_exists("$LOG_DIR/coverage.action")) {
    $fp = fopen("$LOG_DIR/coverage.action", "r");
    flock($fp, LOCK_SH);
    while($line = fgets($fp)) {
      if (preg_match('/# (.*?) :: (.*?)$/', $line, $match)) {
        $fn = trim($match[1]);
        $debug_list[$fn]['.'] = trim($match[2]);
      } else if (preg_match('/@@@@@@ (.*?)\t(.*?)$/', $line, $match)) {
        $label = trim($match[1]);
        $debug_list[$fn][$label] = trim($match[2]);
      }
    }
    pclose($fp);
  }

  $tmp_fn = realpath($__validate_tpl);
  $ti = strftime('%Y/%m/%d %H:%M:%S', filemtime($tmp_fn));
  if ($__debug_action) {
    $debug_list[$tmp_fn][$__debug_action] = strftime('%Y/%m/%d %H:%M:%S');
    $debug_list[$tmp_fn]['.'] = $ti;
  }
  if ($__debug_refresh) {
    $ti = strftime('%Y/%m/%d %H:%M:%S', filemtime($tmp_fn));
    $debug_list[$tmp_fn]['_REFRESH'] = strftime('%Y/%m/%d %H:%M:%S');
    $debug_list[$tmp_fn]['.'] = $ti;
  }

  ksort($debug_list);
  $fp = fopen("$LOG_DIR/coverage.action", "w");
  flock($fp, LOCK_EX);
  foreach($debug_list as $fn => $tmp) {
    fwrite($fp, "# $fn :: {$tmp['.']}\n");
    foreach($tmp as $key => $val) {
      if ($key == '.') continue;
      fwrite($fp, "\t@@@@@@ $key\t$val\n");
    }
  }
  fclose($fp);
}


$__frame = $__sess['__frame'];
if(!$__sess['__sess_seq']) $__sess['__sess_seq'] = 0;

?>
