<?php
/* vim: set expandtab tabstop=2 shiftwidth=2: */

function common_constructor(&$win, &$rec, $field_name, $attr1, $attr2) {
	if (!is_array($rec)) $rec = array();

	if (strstr($field_name, 'ERRSTR')) return;

	$data = htmlspecialchars(trim($rec[$field_name]));
  if ($field_name[0] == '_') {
    $data = $rec[$field_name];
  } else {
    if (!array_key_exists($field_name, $rec)) {
      $data = "\x01\x01\x01\x01";
    }
  }

	if ($attr1 == 'radio_checked') {
    if ($attr2 == $rec[$field_name]) {
      $data = 'checked';
    }
	} else if ($attr1 == 'checkbox_checked') {
    if ($attr2 == $rec[$field_name]) {
      $data = 'checked';
    }
	} else if ($attr1 == 'option_selected') {
    if ($attr2 == $rec[$field_name]) {
      $data = 'selected';
    }
	} else if ($attr1 == 'hidden') {
		$data = str_repeat('*', strlen($rec[$field_name]));
	} else if ($attr1 == 'nl2br') {
	  $data = nl2br(htmlspecialchars(trim($rec[$field_name])));
	} else if ($attr1 == 'raw') {
		$data = $rec[$field_name];
    $tmp = $win->_CONTROL_URL;
    $data = str_replace('_CONTROL_URL', $tmp, $data);
	} else if ($attr1 == 'select' || $attr1 == 'select_search') {
		if ($attr1 == 'select') {
			$srch_fg = false;
		} else {
			$srch_fg = true;
		} 

		if (strstr($field_name, 'PER_PAGE')) {
      global $dict_per_page;
			$data = util::make_options($dict_per_page, $rec[$field_name], $srch_fg);
		}

    if (strstr($field_name, 'GENDER')) {
      global $dict_gender;
			$data = util::make_options($dict_gender, $rec[$field_name], $srch_fg);
    }

		if (strstr($field_name, 'PREF')) {
      global $dict_pref;
			$data = util::make_options($dict_pref, $rec[$field_name], $srch_fg);
		}

    if (strstr($field_name, 'OPT_FG')) {
      global $dict_opt_fg;
      $data = util::make_options($dict_opt_fg, $rec[$field_name], $srch_fg);
    }

    if (strstr($field_name, 'STAFF_TYPE')) {
      global $dict_staff_type;
      $data = util::make_options($dict_staff_type, $rec[$field_name], $srch_fg);
    }

	} else if ($attr1 == 'dict') {
    if (strstr($field_name, 'GENDER')) {
      global $dict_gender;
      $data = $dict_gender[$rec[$field_name]];
    }

    if (strstr($field_name, 'OPT_FG')) {
      global $dict_opt_ft;
      $data = $dict_opt_ft[$rec[$field_name]];
    }

    if (strstr($field_name, 'STAFF_TYPE')) {
      global $dict_staff_type;
      $data = $dict_staff_type[$rec[$field_name]];
    }

  }
  return $data;
}
?>
