<?
/* vim: set expandtab tabstop=2 shiftwidth=2: */

/*
 * PM9 Web Framework
 * (C) 2005, Kunimasa Noda/PM9.com, Inc. <http://www.pm9.com,  kuni@pm9.com>
 * see file LICENSE for license details
 */

list($license, $md5) = split('::', LICENSE);
if (strtoupper($license."::".md5("{$license}pm9frame")) != LICENSE) {
  echo 'ThePM9.com Web Framework -- License Error!!<br>';
  echo 'Please contact us.&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;';
  echo '<a href="hhttp://www.pm9.com">http://www.pm9.com</a><br>';
  echo '<br>';
}

pre_reset_globals();

if ($__post_ap_id) {
  $__AP_ID = $__post_ap_id;
  $__VAR_ID = $__post_pvar_id;
  $__AP_STATE = $__post_ap_state;

  $__sess[$__AP_ID]['__s'] = $__AP_STATE;

  if ($__trace_mode_log) {
    pm9mvc::log("REQUEST: $__AP_ID/$__VAR_ID/$__AP_STATE");
  }

  if ($__trace_mode_ap_sess_dump) {
    include('_include/trace_start.php');
    echo "@@@ EXEC: $__AP_ID/$__AP_STATE\n\n";
    echo '$_ : ';
    var_dump($__portletvars[$__VAR_ID]);
    echo "\n";
    include('_include/trace_end.php');
  }

  if ($__trace_mode_ap_last_state) {
    include('_include/trace_start.php');
    echo "@@@ LAST_STATE: $__AP_ID\n\n";
    var_dump($__ap_last_state[$__AP_ID]);
    echo "\n";
    include('_include/trace_end.php');
  }

  $_ = &$__portletvars[$__VAR_ID];
  $__PVAR_ID = $__VAR_ID;
  if (file_exists(APP_DIR."$__AP_ID/_common.php")) {
    include(APP_DIR."$__AP_ID/_common.php");
  }
  include(APP_DIR."$__AP_ID/{$__AP_STATE}_.php");
}

if (!$__validate_form_list) {
  $__validate_form_list = array();
  $__sess['__sess_seq'] = 0;
} else if (!($_POST['_SESSION_READ_ONLY'] || $_POST['__r'])) {
  end($__validate_form_list);
  $__sess['__sess_seq'] = key($__validate_form_list) + 1;

  $tmp_c = $__sess['__sess_seq'] - 200;
  for($i = 0; $i < $tmp_c; $i++) {
    $__validate_form_list[$i] = array();
  }
}

foreach($__cache_time as $__tmp1 => $__tmp2) {
  if ($__cache_time[$__tmp1] < time() || ($__sess['__sess_seq'] % 60 == 0)) {
    $__cache_time[$__tmp1] = 0;
    $__cache[$__tmp1] = null;
  }
}


$__exec_list = 'EXEC: ';
do {
	$__frame_next = $__frame;
	$__tpl_main = new pm9mvc(TEMPLATE_DIR . $__frame);
	$__tpl_main->setup();
	foreach($__tpl_main->_bl[PM9MVC_TOP_BLOCK] as $__tmp1 => $__tmp2) {
		if (substr($__tmp1, 0, 3) == '_t:') {
			if (!strstr($__tmp2, '&')) continue;
			$__AP_ID = str_replace('&', '', $__tmp2);
			if (!$__cache[$__AP_ID] || $__cache_time[$__AP_ID] < time()) {
        if (!$__sess[$__AP_ID]['__s']) $__sess[$__AP_ID]['__s'] = 'start';
        $__AP_STATE = $__sess[$__AP_ID]['__s'];
        reset_globals();

        if ($__trace_mode_ap_sess_dump) {
          include('_include/trace_start.php');
          echo "@@@ REBUILD: $__AP_ID/$__AP_STATE\n\n";
          echo "\n\n";
          include('_include/trace_end.php');
        }
        $__exec_list .= APP_DIR."$__AP_ID/{$__AP_STATE}.php  ";

        $__PVAR_ID = $__AP_ID;
        $_ =& pm9mvc::get_pvars($__PVAR_ID);
        pm9mvc::clear_last_state($__AP_ID);
        if (file_exists(APP_DIR."$__AP_ID/_common.php")) {
          include(APP_DIR."$__AP_ID/_common.php");
        }
				include(APP_DIR."$__AP_ID/{$__AP_STATE}.php");
			} else {
      }
		}
	}
} while ($__frame != $__frame_next);

if ($__trace_mode_log) {
  pm9mvc::log($__exec_list);
}

$__sess['__frame'] = $__frame;

$tpl_main = new pm9mvc(TEMPLATE_DIR . $__frame);
$tpl_main->setup();
foreach($tpl_main->_bl[PM9MVC_TOP_BLOCK] as $__tmp1 => $__tmp2) {
	if (substr($__tmp1, 0, 3) == '_t:') {
		if (!strstr($__tmp2, '&')) continue;
		$__tmp2a = str_replace('&', '', $__tmp2);
		$tpl_main->assign($__tmp2, $__cache[$__tmp2a]);
	}
}

foreach($__cache_time as $__tmp1 => $__tmp2) {
  if ($__cache_time[$__tmp1] < time()) {
    $__cache_time[$__tmp1] = 0;
    $__cache[$__tmp1] = null;
  }
}


/*
include('_include/trace_start.php');
echo "@@@ __validate_form_list:\n\n";
var_dump($__validate_form_list);
include('_include/trace_end.php');
*/

$resp = $tpl_main->get_contents();
$resp = str_replace('___SESS__SESS_SEQ___', $__sess['__sess_seq'], $resp);

if ($__trace_mode_html_dump) {
  include('_include/trace_start.php');
  echo "@@@ RESPONSE:\n\n";
  echo "_SESSIONID_: ".session_name().'='.session_id()."\n";
  echo "(START)--------------------------------------------------------\n";
  echo "$resp\n\n";
  echo "(END)----------------------------------------------------------\n";
  include('_include/trace_end.php');
}

function pre_reset_globals() {
  global $__globals_key;
  $__globals_key = array_keys($GLOBALS);
}

function reset_globals() {
  global $__globals_key;
  $keys = array_keys($GLOBALS);
  foreach($keys as $tmp => $key) {
    if ($key == '_') continue;
    if (substr($key, 0, 2) == '__') continue;
    if (array_search($key, $__globals_key)) continue;
    unset($GLOBALS[$key]);
  }
}
?>
